// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    AssistenzlisteCreateRequestDTO,
    AssistenzlisteDrucksachenResponseDTO,
    AssistenzlisteResponseDTO,
    AssistenzlistenNameDTO,
    BeteiligungswunschRequestDTO,
    UnansweredVorlagenDTO,
    UnassignedDrucksachenResponseDTO,
    VorgangResponseTableWorkaroundDTO,
    VorlageDetailsDTO,
} from '../models';

export interface AddBeteiligungswunschRequest {
    id: string;
    beteiligungswunschRequestDTO: BeteiligungswunschRequestDTO;
}

export interface AddVorlageRequest {
    assistenzlisteId: string;
    drucksacheId: string;
}

export interface CreateAssistenzlisteRequest {
    assistenzlisteCreateRequestDTO: AssistenzlisteCreateRequestDTO;
}

export interface GetAssistenzlisteRequest {
    id: string;
}

export interface GetVorgangResponsesRequest {
    id: string;
}

export interface GetVorlageDetailsRequest {
    id: string;
}

export interface MakeBeteiligungswunschVisibleRequest {
    drucksacheId: string;
}

export interface ShareAssistenzlisteRequest {
    id: string;
    frist: string;
}

/**
 * no description
 */
export class UeberweisungControllerApi extends BaseAPI {

    /**
     * Trägt einen Beteiligungswunsch zu einer Vorlage ein
     * Trägt Beteiligungswunsch ein
     */
    addBeteiligungswunsch({ id, beteiligungswunschRequestDTO }: AddBeteiligungswunschRequest): Observable<void>
    addBeteiligungswunsch({ id, beteiligungswunschRequestDTO }: AddBeteiligungswunschRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    addBeteiligungswunsch({ id, beteiligungswunschRequestDTO }: AddBeteiligungswunschRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'addBeteiligungswunsch');
        throwIfNullOrUndefined(beteiligungswunschRequestDTO, 'beteiligungswunschRequestDTO', 'addBeteiligungswunsch');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/ueberweisung/assistenzliste/vorlage/{id}/beteiligung'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: beteiligungswunschRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Fügt der Assistenzliste die angegebene Vorlage (Drucksache) hinzu
     * Fügt der Assistenzliste eine weitere Vorlage hinzu
     */
    addVorlage({ assistenzlisteId, drucksacheId }: AddVorlageRequest): Observable<AssistenzlisteDrucksachenResponseDTO>
    addVorlage({ assistenzlisteId, drucksacheId }: AddVorlageRequest, opts?: OperationOpts): Observable<AjaxResponse<AssistenzlisteDrucksachenResponseDTO>>
    addVorlage({ assistenzlisteId, drucksacheId }: AddVorlageRequest, opts?: OperationOpts): Observable<AssistenzlisteDrucksachenResponseDTO | AjaxResponse<AssistenzlisteDrucksachenResponseDTO>> {
        throwIfNullOrUndefined(assistenzlisteId, 'assistenzlisteId', 'addVorlage');
        throwIfNullOrUndefined(drucksacheId, 'drucksacheId', 'addVorlage');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AssistenzlisteDrucksachenResponseDTO>({
            url: '/ueberweisung/assistenzliste/{assistenzlisteId}/vorlage/{drucksacheId}'.replace('{assistenzlisteId}', encodeURI(assistenzlisteId)).replace('{drucksacheId}', encodeURI(drucksacheId)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Legt eine Assistenzliste mit den übergebenen Vorgängen an
     * Assistenzliste anlegen
     */
    createAssistenzliste({ assistenzlisteCreateRequestDTO }: CreateAssistenzlisteRequest): Observable<AssistenzlisteResponseDTO>
    createAssistenzliste({ assistenzlisteCreateRequestDTO }: CreateAssistenzlisteRequest, opts?: OperationOpts): Observable<AjaxResponse<AssistenzlisteResponseDTO>>
    createAssistenzliste({ assistenzlisteCreateRequestDTO }: CreateAssistenzlisteRequest, opts?: OperationOpts): Observable<AssistenzlisteResponseDTO | AjaxResponse<AssistenzlisteResponseDTO>> {
        throwIfNullOrUndefined(assistenzlisteCreateRequestDTO, 'assistenzlisteCreateRequestDTO', 'createAssistenzliste');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AssistenzlisteResponseDTO>({
            url: '/ueberweisung/anlegen',
            method: 'POST',
            headers,
            body: assistenzlisteCreateRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Gibt die Liste an Drucksachen die auf der Assistenzliste stehen
     * Lädt eine Assistenzliste
     */
    getAssistenzliste({ id }: GetAssistenzlisteRequest): Observable<AssistenzlisteDrucksachenResponseDTO>
    getAssistenzliste({ id }: GetAssistenzlisteRequest, opts?: OperationOpts): Observable<AjaxResponse<AssistenzlisteDrucksachenResponseDTO>>
    getAssistenzliste({ id }: GetAssistenzlisteRequest, opts?: OperationOpts): Observable<AssistenzlisteDrucksachenResponseDTO | AjaxResponse<AssistenzlisteDrucksachenResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getAssistenzliste');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AssistenzlisteDrucksachenResponseDTO>({
            url: '/ueberweisung/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Namen der Assistenzlisten
     * Lädt die Namen der Assistenzlisten
     */
    getAssistenzlistenNames(): Observable<Array<AssistenzlistenNameDTO>>
    getAssistenzlistenNames(opts?: OperationOpts): Observable<AjaxResponse<Array<AssistenzlistenNameDTO>>>
    getAssistenzlistenNames(opts?: OperationOpts): Observable<Array<AssistenzlistenNameDTO> | AjaxResponse<Array<AssistenzlistenNameDTO>>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<AssistenzlistenNameDTO>>({
            url: '/ueberweisung/assistenzlisten/names',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Liste an nicht beantworteten Vorlagen zur Überweisung
     * Lädt die Vorlagenliste
     */
    getUnansweredVorlagen(): Observable<Array<UnansweredVorlagenDTO>>
    getUnansweredVorlagen(opts?: OperationOpts): Observable<AjaxResponse<Array<UnansweredVorlagenDTO>>>
    getUnansweredVorlagen(opts?: OperationOpts): Observable<Array<UnansweredVorlagenDTO> | AjaxResponse<Array<UnansweredVorlagenDTO>>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<UnansweredVorlagenDTO>>({
            url: '/ueberweisung/ausschuesse/unanswered',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Gibt die Liste an Drucksachen die noch nicht an Ausschüsse überwiesen wurden
     * Gibt eine Liste an Drucksachen
     */
    getUnassignedDrucksachen(): Observable<Array<UnassignedDrucksachenResponseDTO>>
    getUnassignedDrucksachen(opts?: OperationOpts): Observable<AjaxResponse<Array<UnassignedDrucksachenResponseDTO>>>
    getUnassignedDrucksachen(opts?: OperationOpts): Observable<Array<UnassignedDrucksachenResponseDTO> | AjaxResponse<Array<UnassignedDrucksachenResponseDTO>>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<UnassignedDrucksachenResponseDTO>>({
            url: '/ueberweisung/unassigned',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Liste an Beteiligungswünsche zu einem Vorgang
     * Lädt die Beteiligungswünsche
     */
    getVorgangResponses({ id }: GetVorgangResponsesRequest): Observable<Array<VorgangResponseTableWorkaroundDTO>>
    getVorgangResponses({ id }: GetVorgangResponsesRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<VorgangResponseTableWorkaroundDTO>>>
    getVorgangResponses({ id }: GetVorgangResponsesRequest, opts?: OperationOpts): Observable<Array<VorgangResponseTableWorkaroundDTO> | AjaxResponse<Array<VorgangResponseTableWorkaroundDTO>>> {
        throwIfNullOrUndefined(id, 'id', 'getVorgangResponses');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<VorgangResponseTableWorkaroundDTO>>({
            url: '/ueberweisung/assistenzlisten/vorgang/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Detailinformationen zu einem Vorgang
     * Lädt die Detailinformationen
     */
    getVorlageDetails({ id }: GetVorlageDetailsRequest): Observable<VorlageDetailsDTO>
    getVorlageDetails({ id }: GetVorlageDetailsRequest, opts?: OperationOpts): Observable<AjaxResponse<VorlageDetailsDTO>>
    getVorlageDetails({ id }: GetVorlageDetailsRequest, opts?: OperationOpts): Observable<VorlageDetailsDTO | AjaxResponse<VorlageDetailsDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getVorlageDetails');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<VorlageDetailsDTO>({
            url: '/ueberweisung/assistenzlisten/vorlage/{id}/details'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Macht den Beteiligungswunsch des jeweiligen Ausschusses sichtbar
     * Macht Beteiligungswunsch sichtbar
     */
    makeBeteiligungswunschVisible({ drucksacheId }: MakeBeteiligungswunschVisibleRequest): Observable<void>
    makeBeteiligungswunschVisible({ drucksacheId }: MakeBeteiligungswunschVisibleRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    makeBeteiligungswunschVisible({ drucksacheId }: MakeBeteiligungswunschVisibleRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(drucksacheId, 'drucksacheId', 'makeBeteiligungswunschVisible');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/ueberweisung/assistenzliste/vorlage/{drucksacheId}/beteiligung/freigeben'.replace('{drucksacheId}', encodeURI(drucksacheId)),
            method: 'POST',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Gibt eine Assistenzliste für die PAs mit der angegebenen Frist frei
     * Assistenzliste freigeben
     */
    shareAssistenzliste({ id, frist }: ShareAssistenzlisteRequest): Observable<AssistenzlisteResponseDTO>
    shareAssistenzliste({ id, frist }: ShareAssistenzlisteRequest, opts?: OperationOpts): Observable<AjaxResponse<AssistenzlisteResponseDTO>>
    shareAssistenzliste({ id, frist }: ShareAssistenzlisteRequest, opts?: OperationOpts): Observable<AssistenzlisteResponseDTO | AjaxResponse<AssistenzlisteResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'shareAssistenzliste');
        throwIfNullOrUndefined(frist, 'frist', 'shareAssistenzliste');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AssistenzlisteResponseDTO>({
            url: '/ueberweisung/freigeben/{id}/frist/{frist}'.replace('{id}', encodeURI(id)).replace('{frist}', encodeURI(frist)),
            method: 'POST',
            headers,
        }, opts?.responseOpts);
    };

}
